commit 78abd84383a8eac4cee167b49abfb245b3762419
Author: freddy77 <freddy77>
Date:   Wed Aug 26 12:32:11 2009 +0000

    more fixes for varchar(max)/varbinary(max)

diff --git a/ChangeLog b/ChangeLog
index 8e46f72..6558e6f 100644
--- a/ChangeLog
+++ b/ChangeLog
@@ -1,3 +1,8 @@
+Wed Aug 26 14:31:33 CEST 2009    Frediano Ziglio <freddy77_A_gmail_D_com>
+	* src/odbc/sql2tds.c src/odbc/unittests/genparams.c src/tds/data.c:
+	* src/tds/query.c src/tds/tds_checks.c src/tds/token.c:
+	- more fixes for varchar(max)/varbinary(max)
+
 Wed Aug 26 14:18:35 CEST 2009    Frediano Ziglio <freddy77_A_gmail_D_com>
 	* src/dblib/unittests/common.c:
 	- make check now works if configure was launched from another
@@ -1808,4 +1813,4 @@ Wed Jan  9 19:54:43 EST 2008	JK Lowden <jklowden@freetds.org>
 	* ChangeLog-0.82 added because of release
 	
 $FreeTDS$
-$Id: ChangeLog,v 1.2861 2009/08/26 12:19:01 freddy77 Exp $
+$Id: ChangeLog,v 1.2862 2009/08/26 12:32:11 freddy77 Exp $
diff --git a/src/odbc/sql2tds.c b/src/odbc/sql2tds.c
index 7d57bc4..d5493e5 100644
--- a/src/odbc/sql2tds.c
+++ b/src/odbc/sql2tds.c
@@ -53,7 +53,7 @@
 #include <dmalloc.h>
 #endif
 
-TDS_RCSID(var, "$Id: sql2tds.c,v 1.83 2009/05/28 16:23:32 freddy77 Exp $");
+TDS_RCSID(var, "$Id: sql2tds.c,v 1.84 2009/08/26 12:32:11 freddy77 Exp $");
 
 static TDS_INT
 convert_datetime2server(int bindtype, const void *src, TDS_DATETIME * dt)
@@ -366,7 +366,7 @@ odbc_sql2tds(TDS_STMT * stmt, const struct _drecord *drec_ipd, const struct _dre
 			if (curcol->column_data && curcol->column_data_free)
 				curcol->column_data_free(curcol);
 			curcol->column_data_free = NULL;
-			if (dest_type == SYBNTEXT || dest_type == SYBTEXT) {
+			if (is_blob_col(curcol)) {
 				TDSBLOB *blob = (TDSBLOB *) calloc(1, sizeof(TDSBLOB));
 				if (!blob) {
 					odbc_errs_add(&stmt->errs, "HY001", NULL);
diff --git a/src/odbc/unittests/genparams.c b/src/odbc/unittests/genparams.c
index 8411ed6..29ba46d 100644
--- a/src/odbc/unittests/genparams.c
+++ b/src/odbc/unittests/genparams.c
@@ -18,7 +18,7 @@
  * Also we have to check normal char and wide char
  */
 
-static char software_version[] = "$Id: genparams.c,v 1.43 2009/05/27 17:58:02 freddy77 Exp $";
+static char software_version[] = "$Id: genparams.c,v 1.44 2009/08/26 12:32:11 freddy77 Exp $";
 static void *no_unused_var_warn[] = { software_version, no_unused_var_warn };
 
 #ifdef TDS_NO_DM
@@ -432,6 +432,13 @@ AllTests(void)
 		TestInput(SQL_C_BINARY, "VARBINARY(100)", SQL_WVARCHAR, "NVARCHAR(20)", "0x4100450054004F00 -> AETO");
 		TestInput(SQL_C_BINARY, "IMAGE", SQL_WVARCHAR, "NVARCHAR(20)", "0x4100450054004F00 -> AETO");
 	}
+	if (db_is_microsoft() && db_version_int() >= 0x09000000u) {
+		TestInput(SQL_C_CHAR, "VARCHAR(20)", SQL_LONGVARCHAR, "VARCHAR(MAX)", "1EasyTest");
+		TestInput(SQL_C_BINARY, "VARBINARY(20)", SQL_LONGVARBINARY, "VARBINARY(MAX)", "Anything will suite!");
+#ifdef ENABLE_DEVELOPING
+		TestInput(SQL_C_CHAR, "VARCHAR(20)", SQL_LONGVARCHAR, "VARBINARY(MAX)", "1EasyTest");
+#endif
+	}
 }
 
 int
diff --git a/src/tds/data.c b/src/tds/data.c
index c8a4767..c9a5866 100644
--- a/src/tds/data.c
+++ b/src/tds/data.c
@@ -35,7 +35,7 @@
 #include <dmalloc.h>
 #endif
 
-TDS_RCSID(var, "$Id: data.c,v 1.23 2009/08/21 10:11:20 freddy77 Exp $");
+TDS_RCSID(var, "$Id: data.c,v 1.24 2009/08/26 12:32:11 freddy77 Exp $");
 
 /**
  * Set type of column initializing all dependency 
@@ -128,6 +128,24 @@ tds_set_param_type(TDSSOCKET * tds, TDSCOLUMN * curcol, TDS_SERVER_TYPE type)
 		curcol->column_varint_size = 1;
 		curcol->column_cur_size = -1;
 		break;
+	case SYBNTEXT:
+		if (IS_TDS72(tds)) {
+			curcol->column_varint_size = 8;
+			curcol->on_server.column_type = XSYBNVARCHAR;
+		}
+		break;
+	case SYBTEXT:
+		if (IS_TDS72(tds)) {
+			curcol->column_varint_size = 8;
+			curcol->on_server.column_type = XSYBVARCHAR;
+		}
+		break;
+	case SYBIMAGE:
+		if (IS_TDS72(tds)) {
+			curcol->column_varint_size = 8;
+			curcol->on_server.column_type = XSYBVARBINARY;
+		}
+		break;
 	default:
 		break;
 	}
diff --git a/src/tds/query.c b/src/tds/query.c
index 0e96adb..6723a0b 100644
--- a/src/tds/query.c
+++ b/src/tds/query.c
@@ -46,7 +46,7 @@
 
 #include <assert.h>
 
-TDS_RCSID(var, "$Id: query.c,v 1.240 2009/08/25 14:25:35 freddy77 Exp $");
+TDS_RCSID(var, "$Id: query.c,v 1.241 2009/08/26 12:32:11 freddy77 Exp $");
 
 static void tds_put_params(TDSSOCKET * tds, TDSPARAMINFO * info, int flags);
 static void tds7_put_query_params(TDSSOCKET * tds, const char *query, size_t query_len);
@@ -624,7 +624,10 @@ tds_get_column_declaration(TDSSOCKET * tds, TDSCOLUMN * curcol, char *out)
 		break;
 	case SYBVARCHAR:
 	case XSYBVARCHAR:
-		fmt = "VARCHAR(%u)";
+		if (curcol->column_varint_size == 8)
+			fmt = "VARCHAR(MAX)";
+		else
+			fmt = "VARCHAR(%u)";
 		break;
 	case SYBINT1:
 		fmt = "TINYINT";
@@ -673,7 +676,10 @@ tds_get_column_declaration(TDSSOCKET * tds, TDSCOLUMN * curcol, char *out)
 		break;
 	case SYBVARBINARY:
 	case XSYBVARBINARY:
-		fmt = "VARBINARY(%u)";
+		if (curcol->column_varint_size == 8)
+			fmt = "VARBINARY(MAX)";
+		else
+			fmt = "VARBINARY(%u)";
 		break;
 	case SYBNUMERIC:
 		fmt = "NUMERIC(%d,%d)";
@@ -694,7 +700,9 @@ tds_get_column_declaration(TDSSOCKET * tds, TDSCOLUMN * curcol, char *out)
 		break;
 	case SYBNVARCHAR:
 	case XSYBNVARCHAR:
-		if (IS_TDS7_PLUS(tds)) {
+		if (curcol->column_varint_size == 8) {
+			fmt = "NVARCHAR(MAX)";
+		} else if (IS_TDS7_PLUS(tds)) {
 			fmt = "NVARCHAR(%u)";
 			max_len = 4000;
 			size /= 2u;
@@ -1382,6 +1390,9 @@ tds_put_data_info(TDSSOCKET * tds, TDSCOLUMN * curcol, int flags)
 		case 4:
 			tds_put_int(tds, size);
 			break;
+		case 8:
+			tds_put_smallint(tds, 0xffff);
+			break;
 		}
 	}
 
@@ -1456,6 +1467,9 @@ tds_put_data(TDSSOCKET * tds, TDSCOLUMN * curcol)
 		case 2:
 			tds_put_smallint(tds, -1);
 			break;
+		case 8:
+			tds_put_int8(tds, -1);
+			break;
 		default:
 			assert(curcol->column_varint_size);
 			/* FIXME not good for SYBLONGBINARY/SYBLONGCHAR (still not supported) */
@@ -1511,6 +1525,10 @@ tds_put_data(TDSSOCKET * tds, TDSCOLUMN * curcol)
 			    curcol->column_varint_size);
 
 		switch (curcol->column_varint_size) {
+		case 8:
+			tds_put_int8(tds, colsize);
+			tds_put_int(tds, colsize);
+			break;
 		case 4:	/* It's a BLOB... */
 			colsize = MIN(colsize, size);
 			/* mssql require only size */
@@ -1560,6 +1578,9 @@ tds_put_data(TDSSOCKET * tds, TDSCOLUMN * curcol)
 #endif
 			tds_put_n(tds, s, colsize);
 		}
+		/* finish chunk for varchar/varbinary(max) */
+		if (curcol->column_varint_size == 8 && colsize)
+			tds_put_int(tds, 0);
 	} else {
 		/* TODO ICONV handle charset conversions for data */
 		/* put size of data */
diff --git a/src/tds/tds_checks.c b/src/tds/tds_checks.c
index 108c247..fbe6857 100644
--- a/src/tds/tds_checks.c
+++ b/src/tds/tds_checks.c
@@ -44,7 +44,7 @@
 #include <dmalloc.h>
 #endif
 
-TDS_RCSID(var, "$Id: tds_checks.c,v 1.26 2009/08/25 14:25:35 freddy77 Exp $");
+TDS_RCSID(var, "$Id: tds_checks.c,v 1.27 2009/08/26 12:32:11 freddy77 Exp $");
 
 #if ENABLE_EXTRA_CHECKS
 
@@ -191,16 +191,21 @@ tds_check_column_extra(const TDSCOLUMN * column)
 	assert(strlen(column->column_name) < sizeof(column->column_name));
 
 	/* check type and server type same or SQLNCHAR -> SQLCHAR */
+#define SPECIAL(type, server_type, varint) \
+	if (column->column_type == type && column->on_server.column_type == server_type && column->column_varint_size == varint) {} else
+	SPECIAL(SYBTEXT, XSYBVARCHAR, 8)
+	SPECIAL(SYBTEXT, XSYBNVARCHAR, 8)
+	SPECIAL(SYBIMAGE, XSYBVARBINARY, 8)
 	assert(tds_get_cardinal_type(column->on_server.column_type) == column->column_type
-		|| (tds_get_null_type(column->column_type) == column->on_server.column_type 
+		|| (tds_get_null_type(column->column_type) == column->on_server.column_type
 		&& column->column_varint_size == 1 && is_fixed_type(column->column_type)));
 
 	varint_ok = 0;
-	if (is_blob_type(column->column_type)) {
-		assert(column->column_varint_size >= 4);
-	} else if (column->column_varint_size == 8) {
+	if (column->column_varint_size == 8) {
 		assert(column->on_server.column_type == XSYBVARCHAR || column->on_server.column_type == XSYBVARBINARY || column->on_server.column_type == XSYBNVARCHAR || column->on_server.column_type == SYBMSXML);
 		varint_ok = 1;
+	} else if (is_blob_type(column->column_type)) {
+		assert(column->column_varint_size >= 4);
 	} else if (column->column_type == SYBVARIANT) {
 		assert(column->column_varint_size == 4);
 	}
diff --git a/src/tds/token.c b/src/tds/token.c
index 0223375..f61eef6 100644
--- a/src/tds/token.c
+++ b/src/tds/token.c
@@ -42,7 +42,7 @@
 #include <dmalloc.h>
 #endif
 
-TDS_RCSID(var, "$Id: token.c,v 1.373 2009/08/25 14:25:35 freddy77 Exp $");
+TDS_RCSID(var, "$Id: token.c,v 1.374 2009/08/26 12:32:11 freddy77 Exp $");
 
 #define USE_ICONV tds->use_iconv
 
@@ -1659,6 +1659,11 @@ tds_get_data_info(TDSSOCKET * tds, TDSCOLUMN * curcol, int is_param)
 	case 2:
 		/* assure > 0 */
 		curcol->column_size = tds_get_smallint(tds);
+                /* under TDS9 this means ?var???(MAX) */
+		if (curcol->column_size < 0 && IS_TDS72(tds)) {
+			curcol->column_size = 0x3ffffffflu;
+			curcol->column_varint_size = 8;
+		}
 		break;
 	case 1:
 		curcol->column_size = tds_get_byte(tds);

